// Rev. 1.1E  by Shigeo Izumi
// Sep. 12 2018

// This script creates AVR(SMD) and SOT footprint.

{==============================================================================}
Function IsNum(Num: String): Boolean;
Var
   X : Integer;
   I : Integer;

// Function to check an input text (Integer,Floating point)

Begin
     Result := True;
     I := 0;
     For X := 1 to Length(Num) do
         Begin
              If Pos(copy(Num,X,1),'.0123456789') = 0 then
              Begin
                   Result := False;
                   Exit;
              End;

              If Pos('.',copy(Num,X,1)) <> 0 then
              Begin
                   I := I + 1;

                   If I > 1 then
                   Begin
                        Result := False;
                        Exit;
                   End;
              End;
         End;

     If Num = '' then Result := False;
End;

{==============================================================================}
Procedure TForm.Ok_ButtonClick(Sender: TObject);
Var
    Board       : IPCB_Board;
    Track       : IPCB_Track;
    Pad         : IPCB_Pad;
    PadCache    : TPadCache;
    L           : Text ;
//
    x,y         : Tcoord;                 // Position
    xe1         : Singel;                 // X pos for TO***
//
    e           : Single;                 // Pitch
    B1          : Single;                 // Lead Width
    PNTO        : Integer;                // Pin for TO
//
    DL          : Single;                 // Body1 D
    EL          : Single;                 // Body2 E
    BH          : Single;                 // Heatsink1
    BH2         : Single;                 // Heatsink2
//
    LT          : Single;                 // Lead Length L
    L1          : Single;                 // HS Length
    L2          : Single;                 // Inner Length
    LJ          : Single;                 // Junction of lead
//
    B2L         : Single;                 // HS2 Length
    B2W         : Single;                 // HS2 Width
//
    PDN         : Text;                   // Pad Name
    PDS         : Text;                   // Pad Style
//
    PDX,PDY     : Single;                 // Pad X,Y
    PY          : Single;                 // Pad Y
//
    PBX,PBY     : Single;                 // BH Pad X,Y
    PB2X,PB2Y   : Single;                 // BH2 Pad X,Y
//
    PPx,PPy     : Single;                 // Pad Pos X,Y
    PBPx,PBPy   : Single;                 // BH Pad Pos X,Y
    PB2Px,PB2Py : Single;                 // BH2 Pad Pos X,Y
//
    SME         : Text;                   // SolderMaskExpansion
    SOF         : Text;                   // Silk Offset
//
    Jt,Jh,Js    : Single;                 // for pad
    Ja          : Single;                 // for pad
//
    Ax,Ay       : Single;                 // Track           A----B
    Bx,By       : Single;                 // Track           |    |
    Cx,Cy       : Single;                 // Track           |    |
    Dx,Dy       : Single;                 // Track           C----D

// ------------------------------------

Begin
    Board := PCBServer.GetCurrentPCBBoard;
    If (Board = nil) then Exit;


// ------------------------------------ PAD Style

    If  RadioButton1.Checked then PDS := eRectangular ;
    If  RadioButton2.Checked then PDS := eRoundedRectangular ;
    If  RadioButton3.Checked then PDS := eRounded ;

// ------------------------------------ PNTO

    PNTO:= 3;

    If XPComboBox7.Text = '3P' then PNTO := 3   ;
    If XPComboBox7.Text = '4P' then PNTO := 4   ;
    If XPComboBox7.Text = '5P' then PNTO := 5   ;
    If XPComboBox7.Text = '6P' then PNTO := 6   ;
    If XPComboBox7.Text = '7P' then PNTO := 7   ;

// ------------------------------------ Jt

//    Jt:= 0.5;

    If XPComboBox1.Text = '0.1' then Jt := 0.1  ;
    If XPComboBox1.Text = '0.2' then Jt := 0.2  ;
    If XPComboBox1.Text = '0.3' then Jt := 0.3  ;
    If XPComboBox1.Text = '0.4' then Jt := 0.4  ;
    If XPComboBox1.Text = '0.5' then Jt := 0.5  ;
    If XPComboBox1.Text = '0.6' then Jt := 0.6  ;
    If XPComboBox1.Text = '0.7' then Jt := 0.7  ;
    If XPComboBox1.Text = '0.8' then Jt := 0.8  ;
    If XPComboBox1.Text = '0.9' then Jt := 0.9  ;
    If XPComboBox1.Text = '1.0' then Jt := 1.0  ;

// ------------------------------------ Jh

//    Jh:= 0.2;

    If XPComboBox2.Text = '0.1' then Jh := 0.1  ;
    If XPComboBox2.Text = '0.2' then Jh := 0.2  ;
    If XPComboBox2.Text = '0.3' then Jh := 0.3  ;
    If XPComboBox2.Text = '0.4' then Jh := 0.4  ;
    If XPComboBox2.Text = '0.5' then Jh := 0.5  ;
    If XPComboBox2.Text = '0.6' then Jh := 0.6  ;
    If XPComboBox2.Text = '0.7' then Jh := 0.7  ;
    If XPComboBox2.Text = '0.8' then Jh := 0.8  ;
    If XPComboBox2.Text = '0.9' then Jh := 0.9  ;
    If XPComboBox2.Text = '1.0' then Jh := 1.0  ;

// ------------------------------------ Js

//    Js:= 0.5;

    If XPComboBox3.Text = '0.1' then Js := 0.1  ;
    If XPComboBox3.Text = '0.2' then Js := 0.2  ;
    If XPComboBox3.Text = '0.3' then Js := 0.3  ;
    If XPComboBox3.Text = '0.4' then Js := 0.4  ;
    If XPComboBox3.Text = '0.5' then Js := 0.5  ;
    If XPComboBox3.Text = '0.6' then Js := 0.6  ;
    If XPComboBox3.Text = '0.7' then Js := 0.7  ;
    If XPComboBox3.Text = '0.8' then Js := 0.8  ;
    If XPComboBox3.Text = '0.9' then Js := 0.9  ;
    If XPComboBox3.Text = '1.0' then Js := 1.0  ;

// ------------------------------------ JBt

//    Ja:= 0.2;

    If XPComboBox4.Text = '0.1' then Ja := 0.1  ;
    If XPComboBox4.Text = '0.2' then Ja := 0.2  ;
    If XPComboBox4.Text = '0.3' then Ja := 0.3  ;
    If XPComboBox4.Text = '0.4' then Ja := 0.4  ;
    If XPComboBox4.Text = '0.5' then Ja := 0.5  ;
    If XPComboBox4.Text = '0.6' then Ja := 0.6  ;
    If XPComboBox4.Text = '0.7' then Ja := 0.7  ;
    If XPComboBox4.Text = '0.8' then Ja := 0.8  ;

// ------------------------------------ Py

//    Py:= 1.6;

    If XPComboBox5.Text = '0.6' then Py := 0.6  ;         // 0.2mm step
    If XPComboBox5.Text = '0.8' then Py := 0.8  ;
    If XPComboBox5.Text = '1.0' then Py := 1.0  ;
    If XPComboBox5.Text = '1.2' then Py := 1.2  ;
    If XPComboBox5.Text = '1.4' then Py := 1.4  ;
    If XPComboBox5.Text = '1.5' then Py := 1.5  ;         // Added
    If XPComboBox5.Text = '1.6' then Py := 1.6  ;
    If XPComboBox5.Text = '1.8' then Py := 1.8  ;
    If XPComboBox5.Text = '2.0' then Py := 2.0  ;
    If XPComboBox5.Text = '2.2' then Py := 2.2  ;
    If XPComboBox5.Text = '2.4' then Py := 2.4  ;
    If XPComboBox5.Text = '2.6' then Py := 2.6  ;
    If XPComboBox5.Text = '2.8' then Py := 2.8  ;
    If XPComboBox5.Text = '3.0' then Py := 3.0  ;

// ------------------------------------ Input Error

   If IsNum(Edit1.text)= False then      // Edit1 (e:Pitch)
      Begin
           Edit1.Font.Color := clRed;
           Exit;
      End Else
      Begin
           Edit1.Font.Color := clWindowText;
      End;

   If IsNum(Edit2.text)= False then      // Edit2 (B1:Lead Width)
      Begin
           Edit2.Font.Color := clRed;
           Exit;
      End Else
      Begin
           Edit2.Font.Color := clWindowText;
      End;

   If IsNum(Edit3.text)= False then      // Edit3 (DL:Body1 D)
      Begin
           Edit3.Font.Color := clRed;
           Exit;
      End Else
      Begin
           Edit3.Font.Color := clWindowText;
      End;

   If IsNum(Edit4.text)= False then      // Edit4 (EL:Body2 E)
      Begin
           Edit4.Font.Color := clRed;
           Exit;
      End Else
      Begin
           Edit4.Font.Color := clWindowText;
      End;

   If IsNum(Edit5.text)= False then      // Edit5 (BH:Heatsink)
      Begin
           Edit5.Font.Color := clRed;
           Exit;
      End Else
      Begin
           Edit5.Font.Color := clWindowText;
      End;

   If IsNum(Edit6.text)= False then      // Edit6 (LT:Lead Length L)
      Begin
           Edit6.Font.Color := clRed;
           Exit;
      End Else
      Begin
           Edit6.Font.Color := clWindowText;
      End;

   If IsNum(Edit7.text)= False then      // Edit7 (L1:HS Length)
      Begin
           Edit7.Font.Color := clRed;
           Exit;
      End Else
      Begin
           Edit7.Font.Color := clWindowText;
      End;

   If IsNum(Edit8.text)= False then      // Edit8 (L2:Inner Length)
      Begin
           Edit8.Font.Color := clRed;
           Exit;
      End Else
      Begin
           Edit8.Font.Color := clWindowText;
      End;

   If IsNum(Edit9.text)= False then      // Edit9 (LJ:Junction of lead)
      Begin
           Edit9.Font.Color := clRed;
           Exit;
      End Else
      Begin
           Edit9.Font.Color := clWindowText;
      End;

   If IsNum(Edit10.text)= False then      // Edit10 (B2L:HS2 Length)
      Begin
           Edit10.Font.Color := clRed;
           Exit;
      End Else
      Begin
           Edit10.Font.Color := clWindowText;
      End;

   If IsNum(Edit11.text)= False then      // Edit11 (B2W:HS2 Width)
      Begin
           Edit11.Font.Color := clRed;
           Exit;
      End Else
      Begin
           Edit11.Font.Color := clWindowText;
      End;

   If IsNum(Edit12.text)= False then      // Edit12 (BH2)
      Begin
           Edit12.Font.Color := clRed;
           Exit;
      End Else
      Begin
           Edit12.Font.Color := clWindowText;
      End;

 // ------------------------------------ Size

    e           := StrToFloat(Edit1.Text)    ;
    e           := RoundTo(e + 0.001,-2)     ;   // Decimal point : -2
    Edit1.text  := e;

    B1          := StrToFloat(Edit2.Text)    ;
    B1          := RoundTo(B1 + 0.001,-2)    ;   // Decimal point : -2
    Edit2.text  := B1;

    DL          := StrToFloat(Edit3.Text)    ;
    DL          := RoundTo(DL + 0.001,-2)    ;   // Decimal point : -2
    Edit3.text  := DL;

    EL          := StrToFloat(Edit4.Text)    ;
    EL          := RoundTo(EL + 0.001,-2)    ;   // Decimal point : -2
    Edit4.text  := EL;

    BH          := StrToFloat(Edit5.Text)    ;
    BH          := RoundTo(BH + 0.001,-2)    ;   // Decimal point : -2
    Edit5.text  := BH;

    LT          := StrToFloat(Edit6.Text)    ;
    LT          := RoundTo(LT + 0.001,-2)    ;   // Decimal point : -2
    Edit6.text  := LT;

    L1          := StrToFloat(Edit7.Text)    ;
    L1          := RoundTo(L1 + 0.001,-2)    ;   // Decimal point : -2
    Edit7.text  := L1;

    L2          := StrToFloat(Edit8.Text)    ;
    L2          := RoundTo(L2 + 0.001,-2)    ;   // Decimal point : -2
    Edit8.text  := L2;

    LJ          := StrToFloat(Edit9.Text)    ;
    LJ          := RoundTo(LJ + 0.001,-2)    ;   // Decimal point : -2
    Edit9.text  := LJ;

    B2L         := StrToFloat(Edit10.Text)   ;
    B2L         := RoundTo(B2L + 0.001,-2)   ;   // Decimal point : -2
    Edit10.text := B2L;

    B2W         := StrToFloat(Edit11.Text)   ;
    B2W         := RoundTo(B2W + 0.001,-2)   ;   // Decimal point : -2
    Edit11.text := B2W;

    BH2         := StrToFloat(Edit12.Text)   ;
    BH2         := RoundTo(BH2 + 0.001,-2)   ;   // Decimal point : -2
    Edit12.text := BH2;

// ------------------------------------ Min / Max

    If  e < 0.2 then
        Begin
        ShowMessage('e is so small ! (Min 0.2mm)');
        Exit;
        End;
    If  e > 6 then
        Begin
        ShowMessage('e is so large ! (Max 6mm)');
        Exit;
        End;


    If  B1 < 0.2 then
        Begin
        ShowMessage('B1 is so small ! (Min 0.2mm)');
        Exit;
        End;
    If  B1 > 2 then
        Begin
        ShowMessage('B1 is so large ! (Max 2mm)');
        Exit;
        End;


    If  DL < 2 then
        Begin
        ShowMessage('D is so small ! (Min 2mm)');
        Exit;
        End;
    If  DL > 17 then
        Begin
        ShowMessage('D is so large ! (Max 17mm)');
        Exit;
        End;


    If  EL < 2 then
        Begin
        ShowMessage('E is so small ! (Min 2mm)');
        Exit;
        End;
    If  EL > 15 then
        Begin
        ShowMessage('E is so large ! (Max 15mm)');
        Exit;
        End;

    If  BH < 1 then
        Begin
        ShowMessage('BH is so small ! (Min 1mm)');
        Exit;
        End;
    If  BH > 17 then
        Begin
        ShowMessage('BH is so large ! (Max 17mm)');
        Exit;
        End;

    If  LT < 0.5 then
        Begin
        ShowMessage('L is so small ! (Min 0.5mm)');
        Exit;
        End;
    If  LT > 10 then
        Begin
        ShowMessage('L is so large ! (Max 10mm)');
        Exit;
        End;

    If  L1 < 0.3 then
        Begin
        ShowMessage('L1 is so small ! (Min 0.3mm)');
        Exit;
        End;
    If  L1 > 10 then
        Begin
        ShowMessage('L1 is so large ! (Max 10mm)');
        Exit;
        End;

    If  L2 < 0 then
        Begin
        ShowMessage('L2 is so small ! (Min 0mm)');
        Exit;
        End;
    If  L2 > 15 then
        Begin
        ShowMessage('L2 is so large ! (Max 15mm)');
        Exit;
        End;

    If  LJ < 0.5 then
        Begin
        ShowMessage('LJ is so small ! (Min 0.5mm)');
        Exit;
        End;
    If  LJ > 5 then
        Begin
        ShowMessage('LJ is so large ! (Max 5mm)');
        Exit;
        End;

    If  B2L < 0.2 then
        Begin
        ShowMessage('B2L is so small ! (Min 0.2mm)');
        Exit;
        End;
    If  B2L > 5 then
        Begin
        ShowMessage('B2L is so large ! (Max 5mm)');
        Exit;
        End;

    If  B2W < 0.2 then
        Begin
        ShowMessage('B2W is so small ! (Min 0.2mm)');
        Exit;
        End;
    If  B2W > 5 then
        Begin
        ShowMessage('B2W is so large ! (Max 5mm)');
        Exit;
        End;

    If  BH2 < 0 then
        Begin
        ShowMessage('BH2 is so small ! (Min 0mm)');
        Exit;
        End;
    If  BH2 > 17 then
        Begin
        ShowMessage('BH2 is so large ! (Max 17mm)');
        Exit;
        End;


// ------------------------------------ Size Error Check

    If  B1  > 1.5 * e  then
        Begin
        ShowMessage('Contradiction between B1 and e');
        Exit;
        End;

    If  BH  > DL  then
        Begin
        ShowMessage('Contradiction between BH and D');
        Exit;
        End;

    If RadioButton4.Checked = False then Begin

    If  LJ  > LT  then
        Begin
        ShowMessage('Contradiction between L and LJ');
        Exit;
        End;

    End;

// --------------------------

    If RadioButton7.Checked then Begin          // Check pitch vs D

    If  e * (PNTO - 1)  > DL  then
        Begin
        ShowMessage('Contradiction between D and e');
        Exit;
        End;

    End Else
    Begin

    If  e * 2  > DL  then
        Begin
        ShowMessage('Contradiction between D and e');
        Exit;
        End;

    End;

// --------------------------

    If RadioButton5.Checked then
    Begin
        If  LT  <> L1  then
        Begin
        ShowMessage('For SOT 223, L and L1 should be the same value');
        Exit;
        End;
    End;

// --------------------------

    If RadioButton6.Checked or RadioButton7.Checked  then
    Begin

// ----------------

    If  BH2  > BH  then
    Begin
    ShowMessage('Contradiction between BH and BH2');
    Exit;
    End;

// ----------------

    If  LJ  > LT - 0.1  then
    Begin
    ShowMessage('LJ size should not exceed L - 0.1 mm');
    Exit;
    End;

// ----------------

    If  L2  > EL  then
    Begin
    ShowMessage('Contradiction between E and L2');
    Exit;
    End;

// ----------------

    If  B2L  > LT  then
    Begin
    ShowMessage('Contradiction between L and B2L');
    Exit;
    End;

// ----------------

    If  L2  = 0  then
    Begin
    BH2 := 0;
    Edit12.text := BH2;
    End;

// ----------------

    If  BH2 = 0  then
    Begin
    L2  := 0;
    Edit8.text := L2;
    End;

// ----------------

    End;

// --------------------------


// ------------------------------------ Position

    ShowMessage('Click on the placement position');

    PCBServer.PreProcess;

    Board.ChooseLocation(x,y,'Mouse Position' )  ;

        x := CoordToMMs(x);
        y := CoordToMMs(y);

// -------------------------------------------------------------User's Setting : Start

    SME  := 0.05 ;                        // SolderMaskExpansion
    SOF  := 0.2  ;                        // Silk Offset
    L    := eMechanical1 ;                // Mechanical Layer

// ------------------------------------------------------------ User's Setting : End



// ---------------------------------------------- SOT89-3
    If RadioButton4.Checked then
    Begin

    Ax := x - DL/2 ;
    Ay := y + EL/2 ;
    Bx := x + DL/2 ;
    By := Ay       ;
    Cx := Ax       ;
    Cy := y - EL/2 ;
    Dx := Bx       ;
    Dy := Cy       ;

// ---------------- Silk

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Ax-SOF);
    Track.Y1          := MMsToCoord(Ay+SOF);
    Track.X2          := MMsToCoord(Bx+SOF);
    Track.Y2          := MMsToCoord(By+SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Bx+SOF);
    Track.Y1          := MMsToCoord(By+SOF);
    Track.X2          := MMsToCoord(Dx+SOF);
    Track.Y2          := MMsToCoord(Dy-SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Dx+SOF);
    Track.Y1          := MMsToCoord(Dy-SOF);
    Track.X2          := MMsToCoord(Cx-SOF);
    Track.Y2          := MMsToCoord(Cy-SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Cx-SOF);
    Track.Y1          := MMsToCoord(Cy-SOF);
    Track.X2          := MMsToCoord(Ax-SOF);
    Track.Y2          := MMsToCoord(Ay+SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

// ---------------- Cross Mark

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-1);
    Track.Y1          := MMsToCoord(y);
    Track.X2          := MMsToCoord(x+1);
    Track.Y2          := MMsToCoord(y);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x);
    Track.Y1          := MMsToCoord(y-1);
    Track.X2          := MMsToCoord(x);
    Track.Y2          := MMsToCoord(y+1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ---------------- Body

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Ax);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(Bx);
    Track.Y2          := MMsToCoord(By);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

     Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Bx);
    Track.Y1          := MMsToCoord(By);
    Track.X2          := MMsToCoord(Dx);
    Track.Y2          := MMsToCoord(Dy);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Dx);
    Track.Y1          := MMsToCoord(Dy);
    Track.X2          := MMsToCoord(Cx);
    Track.Y2          := MMsToCoord(Cy);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Cx);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(Ax);
    Track.Y2          := MMsToCoord(Ay);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ---------------- Lead

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x-B1/2);
    Track.Y2          := MMsToCoord(Cy-LT);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x+B1/2);
    Track.Y2          := MMsToCoord(Cy-LT);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-B1/2);
    Track.Y1          := MMsToCoord(Cy-LT);
    Track.X2          := MMsToCoord(x+B1/2);
    Track.Y2          := MMsToCoord(Cy-LT);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ------

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-e-B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x-e-B1/2);
    Track.Y2          := MMsToCoord(Cy-LT);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-e+B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x-e+B1/2);
    Track.Y2          := MMsToCoord(Cy-LT);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-e-B1/2);
    Track.Y1          := MMsToCoord(Cy-LT);
    Track.X2          := MMsToCoord(x-e+B1/2);
    Track.Y2          := MMsToCoord(Cy-LT);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ------

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+e-B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x+e-B1/2);
    Track.Y2          := MMsToCoord(Cy-LT);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+e+B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x+e+B1/2);
    Track.Y2          := MMsToCoord(Cy-LT);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+e-B1/2);
    Track.Y1          := MMsToCoord(Cy-LT);
    Track.X2          := MMsToCoord(x+e+B1/2);
    Track.Y2          := MMsToCoord(Cy-LT);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ---------------- Heat Lead

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-BH/2);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(x-BH/2);
    Track.Y2          := MMsToCoord(Ay+L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+BH/2);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(x+BH/2);
    Track.Y2          := MMsToCoord(Ay+L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-BH/2);
    Track.Y1          := MMsToCoord(Ay+L1);
    Track.X2          := MMsToCoord(x+BH/2);
    Track.Y2          := MMsToCoord(Ay+L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);


// ---------------- Pad

    PBX   := BH + 2 * Ja  ;
    PBY   := L1 + 2 * Ja  ;
    PBPx  := x   ;
    PBPy  := Ay + L1 + Ja - PBY/2 ;

// ------
    PDX   := B1 + 2 * Js   ;
    PDY   := Py  ;
    PPx   := x - e ;
    PPy   := Cy - LT -Jt + PDY/2 ;

// ------

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(PBPx);
    Pad.y := MMsToCoord(PBPy);

    Pad.TopXSize := MMsToCoord(PBX);
    Pad.TopYSize := MMsToCoord(PBY);
    Pad.TopShape := eRectangular ;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := '4' ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);

// ------ Pin1

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(PPx);
    Pad.y := MMsToCoord(PPy);

    Pad.TopXSize := MMsToCoord(PDX);
    Pad.TopYSize := MMsToCoord(PDY);
    Pad.TopShape := PDS;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := '1' ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);

// ------ Pin2

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(x);
    Pad.y := MMsToCoord(PPy);

    Pad.TopXSize := MMsToCoord(PDX);
    Pad.TopYSize := MMsToCoord(PDY);
    Pad.TopShape := PDS;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := '2' ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);

// ------ Pin3

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(x + e);
    Pad.y := MMsToCoord(PPy);

    Pad.TopXSize := MMsToCoord(PDX);
    Pad.TopYSize := MMsToCoord(PDY);
    Pad.TopShape := PDS;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := '3' ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);


    End;
// ----------------------------------------------



// ---------------------------------------------- SOT223
    If RadioButton5.Checked then
    Begin
    Ax := x - DL/2 ;
    Ay := y + EL/2 ;
    Bx := x + DL/2 ;
    By := Ay       ;
    Cx := Ax       ;
    Cy := y - EL/2 ;
    Dx := Bx       ;
    Dy := Cy       ;

// ---------------- Silk

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Ax-SOF);
    Track.Y1          := MMsToCoord(Ay+SOF);
    Track.X2          := MMsToCoord(Bx+SOF);
    Track.Y2          := MMsToCoord(By+SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Bx+SOF);
    Track.Y1          := MMsToCoord(By+SOF);
    Track.X2          := MMsToCoord(Dx+SOF);
    Track.Y2          := MMsToCoord(Dy-SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Dx+SOF);
    Track.Y1          := MMsToCoord(Dy-SOF);
    Track.X2          := MMsToCoord(Cx-SOF);
    Track.Y2          := MMsToCoord(Cy-SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Cx-SOF);
    Track.Y1          := MMsToCoord(Cy-SOF);
    Track.X2          := MMsToCoord(Ax-SOF);
    Track.Y2          := MMsToCoord(Ay+SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

// ---------------- Cross Mark

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-1);
    Track.Y1          := MMsToCoord(y);
    Track.X2          := MMsToCoord(x+1);
    Track.Y2          := MMsToCoord(y);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x);
    Track.Y1          := MMsToCoord(y-1);
    Track.X2          := MMsToCoord(x);
    Track.Y2          := MMsToCoord(y+1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ---------------- Body

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Ax);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(Bx);
    Track.Y2          := MMsToCoord(By);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

     Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Bx);
    Track.Y1          := MMsToCoord(By);
    Track.X2          := MMsToCoord(Dx);
    Track.Y2          := MMsToCoord(Dy);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Dx);
    Track.Y1          := MMsToCoord(Dy);
    Track.X2          := MMsToCoord(Cx);
    Track.Y2          := MMsToCoord(Cy);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Cx);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(Ax);
    Track.Y2          := MMsToCoord(Ay);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ---------------- Lead

// 1pin
    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x-B1/2);
    Track.Y2          := MMsToCoord(Cy-L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x+B1/2);
    Track.Y2          := MMsToCoord(Cy-L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-B1/2);
    Track.Y1          := MMsToCoord(Cy-L1);
    Track.X2          := MMsToCoord(x+B1/2);
    Track.Y2          := MMsToCoord(Cy-L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    // LJ
    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-B1/2);
    Track.Y1          := MMsToCoord(Cy-L1+LJ);
    Track.X2          := MMsToCoord(x+B1/2);
    Track.Y2          := MMsToCoord(Cy-L1+LJ);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// 2pin
    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-e-B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x-e-B1/2);
    Track.Y2          := MMsToCoord(Cy-L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-e+B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x-e+B1/2);
    Track.Y2          := MMsToCoord(Cy-L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-e-B1/2);
    Track.Y1          := MMsToCoord(Cy-L1);
    Track.X2          := MMsToCoord(x-e+B1/2);
    Track.Y2          := MMsToCoord(Cy-L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    // LJ
    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-e-B1/2);
    Track.Y1          := MMsToCoord(Cy-L1+LJ);
    Track.X2          := MMsToCoord(x-e+B1/2);
    Track.Y2          := MMsToCoord(Cy-L1+LJ);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// 3pin
    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+e-B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x+e-B1/2);
    Track.Y2          := MMsToCoord(Cy-L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+e+B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x+e+B1/2);
    Track.Y2          := MMsToCoord(Cy-L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+e-B1/2);
    Track.Y1          := MMsToCoord(Cy-L1);
    Track.X2          := MMsToCoord(x+e+B1/2);
    Track.Y2          := MMsToCoord(Cy-L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    // LJ
    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+e-B1/2);
    Track.Y1          := MMsToCoord(Cy-L1+LJ);
    Track.X2          := MMsToCoord(x+e+B1/2);
    Track.Y2          := MMsToCoord(Cy-L1+LJ);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ---------------- Heat Lead

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-BH/2);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(x-BH/2);
    Track.Y2          := MMsToCoord(Ay+L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+BH/2);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(x+BH/2);
    Track.Y2          := MMsToCoord(Ay+L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-BH/2);
    Track.Y1          := MMsToCoord(Ay+L1);
    Track.X2          := MMsToCoord(x+BH/2);
    Track.Y2          := MMsToCoord(Ay+L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    // LJ
    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-BH/2);
    Track.Y1          := MMsToCoord(Ay+L1-LJ);
    Track.X2          := MMsToCoord(x+BH/2);
    Track.Y2          := MMsToCoord(Ay+L1-LJ);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ---------------- Pad

    PBX   := BH + 2 * Js   ;
    PBY   := Py  ;
    PBPx  := x   ;
    PBPy  := Ay + L1 + Jt - PBY/2 ;

// ------
    PDX   := B1 + 2 * Js   ;
    PDY   := Py  ;
    PPx   := x - e ;
    PPy   := Cy - LT -Jt + PDY/2 ;

// ------

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(PBPx);
    Pad.y := MMsToCoord(PBPy);

    Pad.TopXSize := MMsToCoord(PBX);
    Pad.TopYSize := MMsToCoord(PBY);
    Pad.TopShape := eRectangular ;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := '4' ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);

// ------ Pin1

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(PPx);
    Pad.y := MMsToCoord(PPy);

    Pad.TopXSize := MMsToCoord(PDX);
    Pad.TopYSize := MMsToCoord(PDY);
    Pad.TopShape := PDS;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := '1' ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);

// ------ Pin2

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(x);
    Pad.y := MMsToCoord(PPy);

    Pad.TopXSize := MMsToCoord(PDX);
    Pad.TopYSize := MMsToCoord(PDY);
    Pad.TopShape := PDS;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := '2' ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);

// ------ Pin3

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(x + e);
    Pad.y := MMsToCoord(PPy);

    Pad.TopXSize := MMsToCoord(PDX);
    Pad.TopYSize := MMsToCoord(PDY);
    Pad.TopShape := PDS;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := '3' ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);


    End;
// ----------------------------------------------


// ---------------------------------------------- DPAK
    If RadioButton6.Checked then
    Begin

// ---------------- Cross Mark

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-1);
    Track.Y1          := MMsToCoord(y);
    Track.X2          := MMsToCoord(x+1);
    Track.Y2          := MMsToCoord(y);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x);
    Track.Y1          := MMsToCoord(y-1);
    Track.X2          := MMsToCoord(x);
    Track.Y2          := MMsToCoord(y+1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ----------------

    Ax := x - DL/2    ;
    Ay := y + EL + LT ;
    Bx := x + DL/2    ;
    By := Ay          ;
    Cx := Ax          ;
    Cy := y + LT      ;
    Dx := Bx          ;
    Dy := Cy          ;

// ---------------- Body

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Ax);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(Bx);
    Track.Y2          := MMsToCoord(By);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

     Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Bx);
    Track.Y1          := MMsToCoord(By);
    Track.X2          := MMsToCoord(Dx);
    Track.Y2          := MMsToCoord(Dy);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Dx);
    Track.Y1          := MMsToCoord(Dy);
    Track.X2          := MMsToCoord(Cx);
    Track.Y2          := MMsToCoord(Cy);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Cx);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(Ax);
    Track.Y2          := MMsToCoord(Ay);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ---------------- Silk

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Ax-SOF);
    Track.Y1          := MMsToCoord(Ay+SOF);
    Track.X2          := MMsToCoord(Bx+SOF);
    Track.Y2          := MMsToCoord(By+SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Bx+SOF);
    Track.Y1          := MMsToCoord(By+SOF);
    Track.X2          := MMsToCoord(Dx+SOF);
    Track.Y2          := MMsToCoord(Dy-SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Dx+SOF);
    Track.Y1          := MMsToCoord(Dy-SOF);
    Track.X2          := MMsToCoord(Cx-SOF);
    Track.Y2          := MMsToCoord(Cy-SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Cx-SOF);
    Track.Y1          := MMsToCoord(Cy-SOF);
    Track.X2          := MMsToCoord(Ax-SOF);
    Track.Y2          := MMsToCoord(Ay+SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

// ---------------- Lead

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-B2W/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x-B2W/2);
    Track.Y2          := MMsToCoord(Cy-B2L);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+B2W/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x+B2W/2);
    Track.Y2          := MMsToCoord(Cy-B2L);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-B2W/2);
    Track.Y1          := MMsToCoord(Cy-B2L);
    Track.X2          := MMsToCoord(x+B2W/2);
    Track.Y2          := MMsToCoord(Cy-B2L);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ----------------

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-e-B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x-e-B1/2);
    Track.Y2          := MMsToCoord(y);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-e+B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x-e+B1/2);
    Track.Y2          := MMsToCoord(y);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-e-B1/2);
    Track.Y1          := MMsToCoord(y);
    Track.X2          := MMsToCoord(x-e+B1/2);
    Track.Y2          := MMsToCoord(y);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ------ LJ 1p

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-e-B1/2);
    Track.Y1          := MMsToCoord(y + LJ);
    Track.X2          := MMsToCoord(x-e+B1/2);
    Track.Y2          := MMsToCoord(y + LJ);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ----------------

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+e-B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x+e-B1/2);
    Track.Y2          := MMsToCoord(y);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+e+B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(x+e+B1/2);
    Track.Y2          := MMsToCoord(y);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+e-B1/2);
    Track.Y1          := MMsToCoord(y);
    Track.X2          := MMsToCoord(x+e+B1/2);
    Track.Y2          := MMsToCoord(y);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ------ LJ 2p

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+e-B1/2);
    Track.Y1          := MMsToCoord(y + LJ);
    Track.X2          := MMsToCoord(x+e+B1/2);
    Track.Y2          := MMsToCoord(y + LJ);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ---------------- Heat Lead

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-BH/2);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(x-BH/2);
    Track.Y2          := MMsToCoord(Ay+L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+BH/2);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(x+BH/2);
    Track.Y2          := MMsToCoord(Ay+L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-BH/2);
    Track.Y1          := MMsToCoord(Ay+L1);
    Track.X2          := MMsToCoord(x+BH/2);
    Track.Y2          := MMsToCoord(Ay+L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ---------------- Heat Lead2

    If L2 <> 0 Then
    Begin

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-BH2/2);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(x-BH2/2);
    Track.Y2          := MMsToCoord(Ay-L2);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+BH2/2);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(x+BH2/2);
    Track.Y2          := MMsToCoord(Ay-L2);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-BH2/2);
    Track.Y1          := MMsToCoord(Ay-L2);
    Track.X2          := MMsToCoord(x+BH2/2);
    Track.Y2          := MMsToCoord(Ay-L2);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    End;

 // ---------------- Pad

    PBX   := BH + 2 * Ja   ;
    PBY   := L1 + 2 * Ja   ;
    PBPx  := x             ;
    PBPy  := Ay + L1 + Ja - PBY/2 ;

// ------

    PB2X  := BH2 + 2 * Ja  ;
    PB2Y  := L2  + 2 * Ja  ;
    PB2Px := x             ;
    PB2Py := Ay - L2 - Ja + PB2Y/2 ;

// ------

    PDX   := B1 + 2 * Js   ;
    PDY   := Lj + Jt + Jh  ;
    PPx   := x - e ;
    PPy   := y + LJ + Jh - PDY/2 ;


// -------------------------- Pad BH and BH ---> Num.4

    IF BH = BH2 then
    Begin

    // ----------------------

    PBY := L1 + L2 + 2 * Ja  ;
    PBPy  := Ay + L1 + Ja - PBY/2 ;

    // ----------------------

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(PBPx);
    Pad.y := MMsToCoord(PBPy);

    Pad.TopXSize := MMsToCoord(PBX);
    Pad.TopYSize := MMsToCoord(PBY);
    Pad.TopShape := eRectangular ;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := '4' ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);


    End Else
    Begin
// ---------------- Pad BH

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(PBPx);
    Pad.y := MMsToCoord(PBPy);

    Pad.TopXSize := MMsToCoord(PBX);
    Pad.TopYSize := MMsToCoord(PBY);
    Pad.TopShape := eRectangular ;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := '4A' ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);

// ---------------- Pad BH2

    If L2 <> 0 Then
    Begin

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(PB2Px);
    Pad.y := MMsToCoord(PB2Py);

    Pad.TopXSize := MMsToCoord(PB2X);
    Pad.TopYSize := MMsToCoord(PB2Y);
    Pad.TopShape := eRectangular ;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := '4B' ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);

    End;

// ----------------

    End;
// --------------------------


// ---------------- Pad 1

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(PPx);
    Pad.y := MMsToCoord(PPy);

    Pad.TopXSize := MMsToCoord(PDX);
    Pad.TopYSize := MMsToCoord(PDY);
    Pad.TopShape := PDS;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := '1' ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);

// ---------------- Pad 3

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(PPx + 2 * e);
    Pad.y := MMsToCoord(PPy);

    Pad.TopXSize := MMsToCoord(PDX);
    Pad.TopYSize := MMsToCoord(PDY);
    Pad.TopShape := PDS;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := '3' ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);

    End;

// ----------------------------------------------


// ---------------------------------------------- TO
    If RadioButton7.Checked then
    Begin


// ---------------- Cross Mark

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-1);
    Track.Y1          := MMsToCoord(y);
    Track.X2          := MMsToCoord(x+1);
    Track.Y2          := MMsToCoord(y);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x);
    Track.Y1          := MMsToCoord(y-1);
    Track.X2          := MMsToCoord(x);
    Track.Y2          := MMsToCoord(y+1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ----------------

    Ax := x - DL/2    ;
    Ay := y + EL + LT ;
    Bx := x + DL/2    ;
    By := Ay          ;
    Cx := Ax          ;
    Cy := y + LT      ;
    Dx := Bx          ;
    Dy := Cy          ;

// ---------------- Body

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Ax);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(Bx);
    Track.Y2          := MMsToCoord(By);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

     Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Bx);
    Track.Y1          := MMsToCoord(By);
    Track.X2          := MMsToCoord(Dx);
    Track.Y2          := MMsToCoord(Dy);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Dx);
    Track.Y1          := MMsToCoord(Dy);
    Track.X2          := MMsToCoord(Cx);
    Track.Y2          := MMsToCoord(Cy);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Cx);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(Ax);
    Track.Y2          := MMsToCoord(Ay);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ---------------- Silk

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Ax-SOF);
    Track.Y1          := MMsToCoord(Ay+SOF);
    Track.X2          := MMsToCoord(Bx+SOF);
    Track.Y2          := MMsToCoord(By+SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Bx+SOF);
    Track.Y1          := MMsToCoord(By+SOF);
    Track.X2          := MMsToCoord(Dx+SOF);
    Track.Y2          := MMsToCoord(Dy-SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Dx+SOF);
    Track.Y1          := MMsToCoord(Dy-SOF);
    Track.X2          := MMsToCoord(Cx-SOF);
    Track.Y2          := MMsToCoord(Cy-SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(Cx-SOF);
    Track.Y1          := MMsToCoord(Cy-SOF);
    Track.X2          := MMsToCoord(Ax-SOF);
    Track.Y2          := MMsToCoord(Ay+SOF);
    Track.Width       := MMsToCoord(0.2);
    Track.Layer       := eTopOverLay;
    Board.AddPCBObject(Track);


// -------------------------- Lead and Pad (Setting)


    If PNTO = 3 Then xe1 := x - e       ;
    If PNTO = 4 Then xe1 := x - 1.5 * e ;
    If PNTO = 5 Then xe1 := x - 2 * e   ;
    If PNTO = 6 Then xe1 := x - 2.5 * e   ;
    If PNTO = 7 Then xe1 := x - 3 * e   ;

// ----------------
    PDX   := B1 + 2 * Js   ;
    PDY   := Lj + Jt + Jh  ;
    PPx   := xe1 ;
    PPy   := y + LJ + Jh - PDY/2 ;

// -------------------------- Lead and Pad / Loop Start

    For PDN := 1 to PNTO do
    Begin
// ---------------- Lead

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(xe1 - B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(xe1 - B1/2);
    Track.Y2          := MMsToCoord(y);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(xe1 + B1/2);
    Track.Y1          := MMsToCoord(Cy);
    Track.X2          := MMsToCoord(xe1 + B1/2);
    Track.Y2          := MMsToCoord(y);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(xe1 - B1/2);
    Track.Y1          := MMsToCoord(y);
    Track.X2          := MMsToCoord(xe1 + B1/2);
    Track.Y2          := MMsToCoord(y);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ------ LJ

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(xe1 - B1/2);
    Track.Y1          := MMsToCoord(y + LJ);
    Track.X2          := MMsToCoord(xe1 + B1/2);
    Track.Y2          := MMsToCoord(y + LJ);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

// ---------------- Pad

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(PPx);
    Pad.y := MMsToCoord(PPy);

    Pad.TopXSize := MMsToCoord(PDX);
    Pad.TopYSize := MMsToCoord(PDY);
    Pad.TopShape := PDS;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := PDN ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);

// ----------------

    xe1  := xe1  + e ;
    PPx := PPx + e ;
    End;

// -------------------------- Lead and Pad / Loop End


// ----------------

    PBX   := BH + 2 * Ja   ;
    PBY   := L1 + 2 * Ja   ;
    PBPx  := x             ;
    PBPy  := Ay + L1 + Ja - PBY/2 ;

// ---------------- BH Lead

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-BH/2);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(x-BH/2);
    Track.Y2          := MMsToCoord(Ay+L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+BH/2);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(x+BH/2);
    Track.Y2          := MMsToCoord(Ay+L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-BH/2);
    Track.Y1          := MMsToCoord(Ay+L1);
    Track.X2          := MMsToCoord(x+BH/2);
    Track.Y2          := MMsToCoord(Ay+L1);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);


// ---------------- BH2 Lead

    If L2 <> 0 Then
    Begin


    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-BH2/2);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(x-BH2/2);
    Track.Y2          := MMsToCoord(Ay-L2);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x+BH2/2);
    Track.Y1          := MMsToCoord(Ay);
    Track.X2          := MMsToCoord(x+BH2/2);
    Track.Y2          := MMsToCoord(Ay-L2);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    Track             := PCBServer.PCBObjectFactory(eTrackObject, eNoDimension, eCreate_Default);
    Track.X1          := MMsToCoord(x-BH2/2);
    Track.Y1          := MMsToCoord(Ay-L2);
    Track.X2          := MMsToCoord(x+BH2/2);
    Track.Y2          := MMsToCoord(Ay-L2);
    Track.Width       := MMsToCoord(0.1);
    Track.Layer       := L;
    Board.AddPCBObject(Track);

    End;

// -------------------------- Pad BH and BH2

    PBX   := BH + 2 * Ja   ;
    PBY   := L1 + 2 * Ja   ;
    PBPx  := x             ;
    PBPy  := Ay + L1 + Ja - PBY/2 ;

// ------

    PB2X  := BH2 + 2 * Ja  ;
    PB2Y  := L2  + 2 * Ja  ;
    PB2Px := x             ;
    PB2Py := Ay - L2 - Ja + PB2Y/2 ;

// ----------------

    IF BH = BH2 then
    Begin

// ----------------

    PBY  := L1 + L2 + 2 * Ja     ;
    PBPy := Ay + L1 + Ja - PBY/2 ;

    PDN   :=  IntToStr(PNTO + 1) ;

// ----------------

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(PBPx);
    Pad.y := MMsToCoord(PBPy);

    Pad.TopXSize := MMsToCoord(PBX);
    Pad.TopYSize := MMsToCoord(PBY);
    Pad.TopShape := eRectangular ;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := PDN ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);

// ----------------

    End Else
    Begin
// ---------------- Pad BH

    PDN   :=  IntToStr(PNTO + 1)+ 'A';

// ----------------

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(PBPx);
    Pad.y := MMsToCoord(PBPy);

    Pad.TopXSize := MMsToCoord(PBX);
    Pad.TopYSize := MMsToCoord(PBY);
    Pad.TopShape := eRectangular ;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := PDN ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);

// ---------------- Pad BH2

    If L2 <> 0 Then
    Begin

// ----------------

    PDN   :=  IntToStr(PNTO + 1)+ 'B';

// ----------------

    Pad := PCBServer.PCBObjectFactory(ePadObject, eNoDimension, eCreate_Default);
    Pad.x := MMsToCoord(PB2Px);
    Pad.y := MMsToCoord(PB2Py);

    Pad.TopXSize := MMsToCoord(PB2X);
    Pad.TopYSize := MMsToCoord(PB2Y);
    Pad.TopShape := eRectangular ;
    Pad.HoleSize := MMsToCoord(0);
    Pad.Plated := false ;
    Pad.Layer := eTopLayer;
    Pad.Name := PDN ;

    Padcache  := Pad.GetState_Cache;
    Padcache.SolderMaskExpansion := MMsToCoord(SME);
    Padcache.SolderMaskExpansionValid  := eCacheManual;

    Pad.SetState_Cache                 := Padcache;
    Board.AddPCBObject(Pad);

    End;

// ----------------

    End;

// --------------------------

    End;

// ----------------------------------------------


// -------------------------------------------------------- ReDraw

     PCBServer.PostProcess;
     Client.SendMessage('PCB:Zoom', 'Action=Redraw' , 255, Client.CurrentView);

End;

{==============================================================================}
Procedure TForm.Cancel_ButtonClick(Sender: TObject);
Begin
    Close;
End;

{==============================================================================}
Procedure TForm.RadioButton4Click(Sender: TObject);
Begin

    If RadioButton4.Checked then                       // SOT89-3
    Begin
        Label10.visible := False;                      //B2L
        Edit10.Visible  := False;                      //
        Label11.visible := False;                      //B2W
        Edit11.Visible  := False;                      //
        Label8.visible  := False;                      //L2
        Edit8.Visible   := False;                      //

        Label12.visible := False;                      //BH2
        Edit12.Visible  := False;                      //

        Label9.visible  := False;                      //LJ
        Edit9.Visible   := False;                      //
        XPComboBox7.Enabled := False;

        CheckBox4.Visible   := True;                   // Ja
        XPComboBox4.Visible := True;                   //

        CheckBox5.Visible   := True;                   // Pad-y
        XPComboBox5.Visible := True;                   //

        CheckBox2.Visible   := False;                  // Jh
        XPComboBox2.Visible := False;                  //

    End;

End;

{==============================================================================}
Procedure TForm.RadioButton5Click(Sender: TObject);
Begin

    If RadioButton5.Checked then                       // SOT223
    Begin
        Label10.visible := False;                      //B2L
        Edit10.Visible  := False;                      //
        Label11.visible := False;                      //B2W
        Edit11.Visible  := False;                      //
        Label8.visible  := False;                      //L2
        Edit8.Visible   := False;                      //

        Label12.visible := False;                      //BH2
        Edit12.Visible  := False;                      //

        Label9.visible  := True;                       //LJ
        Edit9.Visible   := True;                       //
        XPComboBox7.Enabled := False;

        CheckBox4.Visible   := False;                  // Ja
        XPComboBox4.Visible := False;                  //

        CheckBox5.Visible   := True;                   // Pad-y
        XPComboBox5.Visible := True;                   //

        CheckBox2.Visible   := False;                  // Jh
        XPComboBox2.Visible := False;                  //

    End;

End;

{==============================================================================}
Procedure TForm.RadioButton6Click(Sender: TObject);
Begin

    If RadioButton6.Checked then                       // DPAK
    Begin
        Label10.visible := True;                       //B2L
        Edit10.Visible  := True;                       //
        Label11.visible := True;                       //B2W
        Edit11.Visible  := True;                       //
        Label8.visible  := True;                       //L2
        Edit8.Visible   := True;                       //

        Label12.visible := True;                       //BH2
        Edit12.Visible  := True;                       //

        Label9.visible  := True;                       //LJ
        Edit9.Visible   := True;                       //
        XPComboBox7.Enabled := False;

        CheckBox4.Visible   := True;                   // Ja
        XPComboBox4.Visible := True;                   //

        CheckBox5.Visible   := False;                  // Pad-y
        XPComboBox5.Visible := False;                  //

        CheckBox2.Visible   := True;                   // Jh
        XPComboBox2.Visible := True;                   //

    End;

End;

{==============================================================================}
Procedure TForm.RadioButton7Click(Sender: TObject);
Begin

    If RadioButton7.Checked then                       // TO*
    Begin
        Label10.visible := False;                      //B2L
        Edit10.Visible  := False;                      //
        Label11.visible := False;                      //B2W
        Edit11.Visible  := False;                      //
        Label8.visible  := True;                       //L2
        Edit8.Visible   := True;                       //

        Label12.visible := True;                       //BH2
        Edit12.Visible  := True;                       //

        Label9.visible  := True;                       //LJ
        Edit9.Visible   := True;                       //
        XPComboBox7.Enabled := True;

        CheckBox4.Visible   := True;                   // Ja
        XPComboBox4.Visible := True;                   //

        CheckBox5.Visible   := False;                  // Pad-y
        XPComboBox5.Visible := False;                  //

        CheckBox2.Visible   := True;                   // Jh
        XPComboBox2.Visible := True;                   //

    End;

End;

{==============================================================================}
Procedure TForm.CheckBox1Click(Sender: TObject);
Begin

    If CheckBox1.Checked then Begin

           XPComboBox1.Enabled     := True;
           End
           Else Begin
           XPComboBox1.Enabled     := False;
           End;

End;

{==============================================================================}
Procedure TForm.CheckBox2Click(Sender: TObject);
Begin
    If CheckBox2.Checked then Begin

           XPComboBox2.Enabled     := True;
           End
           Else Begin
           XPComboBox2.Enabled     := False;
           End;
End;

{==============================================================================}
Procedure TForm.CheckBox3Click(Sender: TObject);
Begin

    If CheckBox3.Checked then Begin

           XPComboBox3.Enabled     := True;
           End
           Else Begin
           XPComboBox3.Enabled     := False;
           End;
End;

{==============================================================================}
Procedure TForm.CheckBox4Click(Sender: TObject);
Begin

    If CheckBox4.Checked then Begin

           XPComboBox4.Enabled     := True;
           End
           Else Begin
           XPComboBox4.Enabled     := False;
           End;
End;


{==============================================================================}
Procedure TForm.CheckBox5Click(Sender: TObject);
Begin
    If CheckBox5.Checked then Begin

           XPComboBox5.Enabled     := True;
           End
           Else Begin
           XPComboBox5.Enabled     := False;
           End;
End;

